#include "dataclass.h"

dataClass::dataClass(QString in)
{
    input=in;
    previousTime = 0;
}

void dataClass::updateData(QString in)
{
    input = in;
}

QString dataClass::getResult(QStringList keywords, QStringList forbiddenApps)
{
    QString result;
    QStringList splittedInput = input.split(";");

    result.append("<h1 style=\"text-align:center\">"+splittedInput.value(0)+"</h1>"); // ID
    result.append("<h2 style=\"text-align:center\">"+splittedInput.value(1)+"</h2>"); // Name
    bool containsKeywords = false;
    title = splittedInput.value(2);
    // window title if suspicious keywords are present
    for(int i=0;i<keywords.length();i++){
        if (title.contains(keywords.at(i))){
            containsKeywords = true;
            result.append("<h3 style=\"background-color:Red;\"><a href=\""+title+"\">"+title+"</a></h3>");
            makeLogEntry = true;
        }
    }
    // window title if no suspicious keywords found
    if (!containsKeywords)
        result.append("<h3><a href=\""+title+"\">"+title+"</a></h3>");

    result.append("<p>"+splittedInput.value(3)+"</p>"); // window ID

    if (splittedInput.value(4)!="1")
        result.append("<p style=\"background-color:Red;\">Number of monitors: "+splittedInput.value(4)+"</p>"); // monitor count
    if (splittedInput.value(5)!="0"){
        result.append("<p style=\"background-color:Red;\">REMOTE SESSION DETECTED!</p>"); // remote session
        makeLogEntry = true;
    }
    // check manufacturer and model and display if virtual machine is detected
    if (splittedInput.value(6).contains("VirtualBox") || splittedInput.value(6).contains("VMware")){
        result.append("<p style=\"background-color:Red;\">VIRTUAL MACHINE DETECTED!</p>");
        makeLogEntry = true;
    }
    time = splittedInput.value(7).toULongLong(); // timestamp in seconds since epoch

    QStringList processes = splittedInput.value(8).split(",");
    QStringList foundForbiddenApps;
    // check if forbidden applications are present
    for (int i=0;i<forbiddenApps.length();i++){
        if (processes.contains(forbiddenApps.at(i)))
            if (!foundForbiddenApps.contains(forbiddenApps.at(i)))
                foundForbiddenApps.append(forbiddenApps.at(i));
    }
    // display any detected fobridden apps
    if (foundForbiddenApps.length()>0){
        result.append("<p style=\"background-color:Red;\">FORBIDDEN APPS DETECTED:<br>" + foundForbiddenApps.join(" ") + "</p>");
        makeLogEntry = true;
    }
    return result;
}

QString dataClass::getTitle()
{
    return title;
}
