#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "networking.h"
#include "dataclass.h"
#include <QLabel>
#include <QVector>
#include <QGridLayout>
#include <QSettings>
#include <QInputDialog>
#include <QMessageBox>
#include <wininet.h>
#include <QPushButton>
#include <QFile>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
public slots:
    void updater(QString);
    void checkConnection();
    void addKeywordsWindow(QString title);
    void modifyKeywords();
private:
    Ui::MainWindow *ui;
    Networking *networkThread;
    QWidget *keywordsWindow;
    QStringList forbiddenApps;
    QStringList keywords;
    int count=0;
    QFile *logFile;
    bool checkPort(int);
    void displayIPaddresses(QString);
};
#endif // MAINWINDOW_H
